
# -------------------------------------------------------------------
# send.pm, authoredb by paal@ekran.no, Mon Aug 28 11:01:47 CEST 2000
#
# this module contains everything related to sending messages from
# webmh. 
#

# -------------------------------------------------------------------
# display compose frame -- shows the frame where the user will write
# the message waiting to be sent.

sub send_display_compose_frame()
{
	($uflag)=@_; # G=group reply, R=reply, F=forward, B=bounce

	my $df_to=""; # default to
	my $df_cc=""; # default cc
	my $df_bcc=""; # default bcc
	my $df_subj=""; # default subj
	my $df_mess=""; # default message
	my $df_attach="";	# attachment datalist.
	my $df_ea; 		# erase attachment
	my $rfdisc; 	# read from disc.
	$rfdisc=0;
	
	if (-e $i_wmhrc."/temp.dta")
	{
		open TXT,"<".$i_wmhrc."/temp.dta";
		$df_to=<TXT>;
		$df_cc=<TXT>;
		$df_bcc=<TXT>;
		$df_subj=<TXT>;
		while (<TXT>)
		{
			$df_mess=$df_mess.$_;
		}	
		close TXT;
		unlink ($i_wmhrc."/temp.dta");
		$rfdisc=1;
	}
	
	if (($uflag eq "G") || ($uflag eq "R") ||
		($uflag eq "F") || ($uflag eq "B")) # grab info
	{
		($df_to,$df_cc,$df_subj,$df_mess)=send_reply_forward_preconf();
		if ($uflag eq "F") { $df_to=""; } # No To: for forwarding.
	}

	$foo=0; # generate the attachment status window
	open TXT,"<".$i_wmhrc."/attach.dta";     # retrive attachement list
	while (<TXT>)
	{
		chomp;
		$line=$_;
		if ($line) {
			if ($foo++==0)
			{
				$df_attach=$df_attach.'
				<tr><td colspan="3">
				<table width="100%">	
					<tr><td valign="top"><b>Attachments:</b><br>
						</td>
						<td valign="top" align="right">';  
			}	
			$df_attach=$df_attach.$line."<br>";
		}
	}
	close TXT;
	if ($foo!=0) # attachements do exist. make exclude buttom at bottom
	{
		$df_attach=$df_attach.'
		</td></tr></table>';
		$df_ea='<input type="submit" name="UATR" value="exclude attachement">';
	} else {
		$df_ea=''; # $ea==erase attachment
	}

	# read and attach signature file
	if (($uflag ne "B") && (!$rfdisc))
	{
		if (-e $i_wmhrc."/signature.dta")
		{
			$df_mess=$df_mess."\n\n\n";
			open TXT,"<".$i_wmhrc."/signature.dta";
			while (<TXT>)
			{
				$df_mess=$df_mess.$_;
			}
			close TXT;
		}
	}


	if ($uflag eq "B") { return (&html_send_bounce); } # for bounce
	return (&html_send($df_to,$df_cc,$df_bcc,$df_subj,$df_attach,$df_ea,$df_mess));
}


# ---------------------------------------------------------------------------
# handle, send data and print recipt

sub send_display_compose_send()
{
	my $atype;
	my $r1=0;
	my $r2=0;
	my $uatt="";

	@flist=();
	$attach=0;

	open TXT,"<".$i_wmhrc."/attach.dta";
	while (<TXT>)
	{
		chomp;
		push @flist,$_;
		$attach++;
	}
	close TXT;

    print '<br><br><br>';
    open DTA,">".$i_cgif."/draft";
    if ($uflag eq "B")
    {
        $uflag="0";
        ($df_to,$df_cc,$df_subj,$df_mess)=send_reply_forward_preconf();
        $uflag="B";
        print DTA "From: ".$df_to."\n";
        print DTA "To: ".$data{"m_to"}."\n";
        print DTA "Subject: ".$df_subj."\n";
        print DTA "X-Resent-From: ".$u_user."\n";
        print DTA $i_xhead1."\n";
    } else {
        $df_mess=$data{"m_message"};
        print DTA "To: ".$data{"m_to"}."\n";
        print DTA "Cc: ".$data{"m_cc"}."\n";
        print DTA "Bcc: ".$data{"m_bcc"}."\n";
        print DTA "Subject: ".$data{"m_subject"}."\n";
        print DTA $i_xhead1."\n";
    }
    print DTA "--------\n";

# there is atleast one attachement make sure the first section is text/plain
	if ($attach>0) { print DTA "#<text/plain [ ]\n"; }

    print DTA $df_mess."\n";

	if (!$data{"m_to"})
	{
		print "There is no recipient for this message.
				Please go back and fill out the <b>To:</b> field.";
		return;
	}

	if ($attach>0)
	{
		$uatt="Attachments:<br><ul>";
		foreach $line (@flist)
		{
			$atype="#application/octet-stream";
			$_=$line;
			if (/jpg^/i) { $atype="#image/jpg"; } # TODO: This doesnt work
			if (/gif^/i) { $atype="#image/gif"; }
			if (/png^/i) { $atype="#image/x-png"; }
			
			($basename,$foo)=fileparse($line);
			
			print DTA $atype." [ ".$basename." ] ".$line."\n";

			$uatt=$uatt.$line."<br>";
		}
    	close DTA;
		$uatt=$uatt."</ul>";

		$draft=$i_cgif."/draft";
		$i="export mhdraft=".$draft."; mhn ".$draft.";";
		($r1)=system ($i);
	} else { close DTA; }
	
    $i=$i_nmh.'/send -draftmessage ./draft';
    ($r2)=system ($i);
    chmod 0600,"./,draft"; # ensure that nobody else reads the draft

	if ($r1!=0) # Check the return values of system commands
		{ print "Err: MIME Encoding package returned ->".$r1."<-<br>\n"; }
	if ($r2!=0)
		{ print "Err: Send draft message returned ->".$r2."<-<br>\n"; }

	if (($r1==0) && ($r2==0))
	{
		unlink $i_wmhrc."/attach.dta";     # unlink attachment list.
	}
	print &html_sent($uflag,$u_user,$uatt);

}

# ---------------------------------------------------------------------------
# when user select either forward or reply, the following sub grabs
# to, subject and message for the composer.

sub send_reply_forward_preconf()
{
    my $cnt;
    my $df_to;
    my $df_cc,$df_c2;
    my $df_subj;
    my $df_mess;

    $cnt=0;
	$df_cc="";
    open TXT,$i_nmh."/show cur -noheader -noshowproc |";
    while (<TXT>)
    {
        chomp;
        if ($cnt==0)
        {
            if (/^From: .*<(.+?)>/) { $df_to=$1; }
            if (/^From: .*(\".+?\")/) { $df_name=$1; } # get realname
            if (/^Cc: (.*\S)\s*$/) { $df_cc=$1; }
            if (/^To: (.*\S)\s*$/) { $df_c2=$1; }
            if (/^Reply-To: (\S+)/) { $df_to=$1; }
            if (/^Subject: \s*(.*)/) { $df_subj=$1; }
        }
        if ($_ eq "") { $cnt++; }
        if ($uflag ne "R") { $head=$head.$_."\n"; } # assemble header

        if ($cnt>0) { # we don't need no header in the reply form
            if ($df_mess eq "")
            {
                if (($uflag eq "R") || ($uflag eq "G")) { # 1'st line reply to
                    if ($df_name)
					{
						$df_mess=$df_name." <".$df_to."> wrote:\n";
					} else { $df_mess="<".$df_to."> wrote:\n"; }
                }
                if ($uflag eq "F") { # 1'st line forward
                    $df_mess="----- Forwarded message from ".
                        $df_name." <".$df_to."> -----\n\n".$head;
                }
                if ($uflag eq "B") {
                    $df_mess="To: <recipient>\n".
                             "Subject: ".$df_subj."\n".
                             "From: ".$df_to."\n".
                             "X-Bounced-From: ".$u_user."\n";
                }
            }
            if (($uflag eq "G") || ($uflag eq "R"))
			{	
                $df_mess=$df_mess."> ".$_."\n";
            } else {
                $df_mess=$df_mess.$_."\n";
            }
        }
    }
    close TXT;
    if ($uflag eq "F") {
        $df_mess=$df_mess.'----- End forwarded message -----'."\n";
    }
	if ($uflag eq "G")
	{
		# tools_debug($df_cc.":".$df_c2.":".$df_to.":".$df_from.":\n","a");
		if ($df_c2) { $df_cc=$df_cc.",".$df_c2; }
	} else {
		$df_cc="";
	}

	unless ($df_subj=~/^(Re|RE|Sv|SV):/)
	{
		$df_subj="Re: ".$df_subj;
	}

    return ($df_to,$df_cc,$df_subj,$df_mess);
}

sub send_browse_attachment()
{
	($path)=@_;

	my $code;
	my $cnt;

	$cnt=0;	
	if (!($path)) { $path=$u_home; }

	open TXT,"/bin/ls -la ".$path." |";
	while (<TXT>)
	{
		chomp;
		push @files,$_;
	}
	close TXT;

	$code='<font face="Courier"><pre><text>';
	foreach $line (@files) # TODO: symbolic links are not supported.
	{
		if (++$cnt>1) {
			$_=$line;	
			if (substr($line,0,1) eq "d")
			{
			s/(\S+)$/<a href="webmh.cgi?UACT=browse&UDIR=$path\/$1">$1<\/a>/g;
				$code=$code.'<font color="#000080">'.$_."\n";
			} elsif ((substr($line,0,1) eq "-"))
			{
			s/(\S+)$/<a href="webmh.cgi?UACT=browse&USEL=$path\/$1">$1<\/a>/g;
				$code=$code.$_."\n";
			}
		}
	}
	$code=$code.'<text></pre>';
	$code=&html_notify("select file to include in attachement.",$code);
	$code="<center><br><br><br>".$code.'<br><br><br></center>';
	return ($code);
}

sub send_attachement_remove()
{
	$code='<br><form action="webmh.cgi" method="post">';

	open TXT,"<".$i_wmhrc."/attach.dta";
	while (<TXT>)
	{
		chomp;
		$code=$code.'<input type="radio" name="UATT"
							value="'.$_.'"> '.$_.'<br>'."\n";
	}
	close TXT;
	$code=$code.'<table width="100%"><tr><td align="right">'.$c_font.'
		<input type="hidden" value="UATR2" name="UACT">
		<input type="hidden" value="2" name="USHOW">
		<input type="submit" value="exclude">
	</td></tr>
	<tr><td>'.$c_font.'<br>
	<b>note</b>: This will not physically delete the file.<br>
	It will only remove it from the attachement list.</td></tr></table>
	';	

	$code="<br>".&html_notify("select attachment to be excluded",$code);
	
	return ($code);
}

sub send_attachement_remove_exec() #TODO: error messages if something goes wrong
{
	my $att=$data{"UATT"};
	my @atl=();

	open TXT,"<".$i_wmhrc.'/attach.dta';
	while (<TXT>)
	{
		chomp;
		$i=$_;
		if ($i ne $att) { push @atl,$i; }
	}
	close TXT;

	open TXT,">".$i_wmhrc.'/attach.dta';
	foreach $line (@atl)
	{
		print TXT $line."\n";
	}
	close TXT;

	$code=send_display_compose_frame();
	return ($code);
}

1;





