
# ------------------------------------------------------------------
# wmh.pm -- authored by paal@ekran.no, Mon Jul  3 14:06:23 CEST 2000

# 
# wmh.pm contains the main section of webmh. webmh aims to be a complete
# web-mail solution based on nmh.
#

use CGI qw(:cgi-lib);
use File::Basename;
use Digest::MD5 qw(md5_hex);

require "/its/trinket/webmh/html.pm";
require "/its/trinket/webmh/authenticate.pm";
require "/its/trinket/webmh/config.pm";
require "/its/trinket/webmh/folders.pm";
require "/its/trinket/webmh/display.pm";
require "/its/trinket/webmh/send.pm";
require "/its/trinket/webmh/tools.pm";

# -------------------------------------------------------------------

&ReadParse(*data);

# uact=
#       mhead=display message headers in top frame
#       mtail=display one message in bottom frame
#		compose=compose a message in both fields
#		dels=delete single message ($ushow==message)
#		movs=move single message ($SFOLDER==to folder, message ==current)
#		delMarked=Delete all marked messages
#		movMarked=Move all marked messages to specific folder
#		expand=expand header
# 		shrink=shrink header
#       attr=remove attachement
#       browse=browse for an attachment on server.


# usage of variables.

# in general:
#
# foo -> a dummy variable that ain't gonna get used outside the immediate loop
# c_* -> mostly environment variables initialized in config.pm
# i_* -> same as above except this is system dependent variables.
# 

$uact=$data{"UACT"};    # user action
$ushow=$data{"USHOW"};  # show  -- used to pass arguments between cgi-bin calls
$uflag=$data{"UFLAG"};  # flags -- used to pass arguments between cgi-bin calls
$ups=$data{"UPS"};	    # ups   -- used to pass text between cgi-bin calls

$sfolder=$data{"SFOLDER"}; # commonly used for selecting folders
$unam=$data{"UNAME"}; # global username
$upwd=$data{"UPWD"};  # global password

#
# -------------------------------------------------------------------
# Initialization

config_init();

$i_remote=$ENV{'REMOTE_HOST'};
if (!$i_remote) { $i_remote=$ENV{'REMOTE_ADDR'}; }

$dat=`/bin/date`;
chomp $dat;

#
# -------------------------------------------------------------------
# user authentication handle

if ($uact eq "logout") { authenticate_logout(); }
if ($uact eq "login")  { $foo=authenticate_setcookie($unam,$upwd); }
$foo=authenticate_parse_cookie(); # check if we have cookie

if ($foo!=1) { authenticate_user(); } # writes the login screen

#
# -------------------------------------------------------------------
# Execute minor changes (change folders, mesg. header state, etc)

if (($sfolder) && ($data{"CFOLDER"} eq "ok") && ($uact eq ""))
{
	system ($i_nmh."/folder +".$sfolder." >/dev/null");
}

if (($uact eq "expand") || ($uact eq "shrink"))
{
	if ($uact eq "expand")
	{		
		tools_change_config_state(1,'$u_expanded');
	} else {
		tools_change_config_state(0,'$u_expanded');
	}
	$uact=""; $ushow="";
}

if ($uact eq "movs") # move single message to a folder
{
	system $i_nmh."/refile cur +".$sfolder;
	$uact=""; 
	$ups="Message%20moved%20to%20".$sfolder.".";
}

if ($uact eq "dels")
{
	system $i_nmh."/rmm ".$ushow;
	$uact=""; $ushow="";
	$ups="Message%20deleted.";
}

if ($data{"delMarked"}) # multi-delete selected messages
{
	(@msglst)=get_msg_list(); # get lst of msgs in this folder
	foreach $id (@msglst)
	{
		if ($data{"d".$id}) # if this message is tagged, delete it.
		{
		    system $i_nmh."/rmm ".$id;
		}
	}
	$uact="mhead";
}

if ($uact eq "movMarked") # multi-delete selected messages
{
	(@msglst)=get_msg_list(); # get lst of msgs in this folder
	foreach $id (@msglst)
	{
		if ($data{"d".$id}) # if this message is tagged, delete it.
		{
			system $i_nmh."/refile ".$id." +".$sfolder;
		}
	}
	$uact="mhead";
}

if ($data{"savesig"})
{
	# save data
	open TXT,">".$i_wmhrc."/signature.dta";
	print TXT $data{"m_signature"}."\n";
	close TXT;
	$ups="Signature data stored.";
	$uact="options"; $ushow=2;
}


if ($data{"chtml"})
{

	if ($data{"hval"} eq "yes")
	{
		tools_debug("found chtml\n",1);
		tools_change_config_state(1,'$u_html');
	} else {
		tools_change_config_state(0,'$u_html');
	}
    $ups="Changed effectuated.";
    $uact="options"; $ushow=2;
}


if ($data{"UATR"}) { $uact="UATR"; }
	
# tools_debug("UACT= ".$uact."\n","a");

#
# -------------------------------------------------------------------
# MAIN

if ($data{"GET"})
{
	$file=$data{"FILE"};
	$_=$file;
	if (/.jpeg/)
	{
		print "Content-type: image/jpg\n\n";
	} elsif (/.gif/) {
		print "Content-type: image/gif\n\n";
	} else {
		print "Content-type: text/html\n\n";
	}
	open TXT,"<".$i_cgif."/mimetmp/".$file;
	while (<TXT>)
	{
		print $_;	
	}
	close TXT;
	
	# print "Location: mimetmp/$file\n\n";
}


print &PrintHeader;

if (($uact eq "") && ($ushow eq "")) # display main root frame
{
	system ("export MAILDROP=$u_maildrop; ".$i_nmh."/inc > /dev/null");
	print &html_display_root_frame();
	exit 0;
}
if ($uact eq "menu") { $c_body=$c_mbody; } # blue background on sidebar menu
if ($ushow!=1) { print &html_head(); }

if ($uact eq "browse")
{
	if ($data{"UDIR"})
	{
		print &send_browse_attachment($data{"UDIR"});
	}
	if ($data{"USEL"})
	{
		open TXT,">>".$i_wmhrc."/attach.dta";
		print TXT $data{"USEL"}."\n";
		close TXT;
		$uact="compose"; $ushow=2; # we need send_display_compose_frame
	}
}

if (($uact eq "UATR") || ($uact eq "UATR2")) # removed enlisted attachement.
{
    if ($ushow==1)
    {
        print &html_display_root_frame_2F($uact,$uflag); exit 0;
    }
	if ($uact eq "UATR")
	{
		storeC(); # store current draft in tmp file
		print &send_attachement_remove();
	}
	if ($uact eq "UATR2") { print &send_attachement_remove_exec(); }
}


if ($uact eq "options")
{
    if ($ushow==1)
    {
        print &html_display_root_frame_2F($uact,$uflag); exit 0;
    }
	config_options();
}


if ($uact eq "compose")
{
	if ($ushow==1)
	{
    	print &html_display_root_frame_2F($uact,$uflag); exit 0;
	}
	if ($data{"UATH"}) # when browse is first selected.
	{
		storeC(); # store current draft in a tmp file.
		print &send_browse_attachment();
	} else {
		if ($ushow==2) { print &send_display_compose_frame($uflag); }
		if ($ushow==3) { send_display_compose_send(); }
	}
}

if ($uact eq "folders")
{
	if ($ushow==1)
	{
	    print &html_display_root_frame_2F($uact,$uflag); exit 0;
	}
	if ($ushow==2) { folders_main(); }
	if ($ushow==3) { folders_handle($data{"NFOLDER"},$uflag); }
}

if ($uact eq "menu") { print &html_display_menu(); } # sidebar menu
if ($uact eq "mhead") { print &display_headers(); }       # display msg. top
if ($uact eq "mtail") { print &display_message($ushow,$ups); } # dsp msg bottom 

print &html_tail();
exit 0;

sub storeC() # stores incoming data when using exclude or browse attachement.
{
	if ($data{"m_to"} || $data{"m__cc"} || $data{"m_bcc"} ||
		$data{"m_subject"} || $data{"m_message"})
	{
      	open TXT,">".$i_wmhrc."/temp.dta"; # store temp data for later use
       	print TXT $data{"m_to"}."\n";
       	print TXT $data{"m_cc"}."\n";
       	print TXT $data{"m_bcc"}."\n";
       	print TXT $data{"m_subject"}."\n";
      	print TXT "\n".$data{"m_message"}."\n";
       	close TXT;
   	}
}

1;
